# Copyright 2022-2023 ETSI TeraFlowSDN - TFS OSG (https://tfs.etsi.org/)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.





import operator
from sqlalchemy import CheckConstraint, Column, DateTime, Float, ForeignKey, Integer, String ,Boolean
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.types import ARRAY
from sqlalchemy.orm import relationship
from typing import Dict
from ._Base import _Base




class OpticalEndPointModel(_Base):
    __tablename__ = 'optical_endpoint'

    endpoint_uuid     = Column(UUID(as_uuid=False), primary_key=True)
    device_uuid       = Column(ForeignKey('device.device_uuid',     ondelete='CASCADE' ), nullable=False, index=True)
   
    name              = Column(String, nullable=False)
    endpoint_type     = Column(String, nullable=False)
   
    created_at        = Column(DateTime, nullable=False)
    updated_at        = Column(DateTime, nullable=False)
   
    device            = relationship('DeviceModel',          back_populates='optical_endpoints') # lazy='selectin'
   
    #link_endpoints    = relationship('LinkEndPointModel',    back_populates='endpoint' )
    #service_endpoints = relationship('ServiceEndPointModel', back_populates='endpoint' )

    def dump_id(self) -> Dict:
        result = {
         
            'device_id'    : self.device.dump_id(),
            'endpoint_uuid': {'uuid': self.endpoint_uuid},
        }
        return result

    def dump(self) -> Dict:
        return {
            'endpoint_id'      : self.dump_id(),
            'name'             : self.name,
            'endpoint_type'    : self.endpoint_type,
           
        }

    def dump_name(self) -> Dict:
        return {
            'endpoint_id'  : self.dump_id(),
            'device_name'  : self.device.device_name,
            'endpoint_name': self.name,
            'endpoint_type': self.endpoint_type,
        }    